Loading...
Searching...
No Matches
gsm48_rest_octets.h File Reference
`#include <stdbool.h>`
`#include <osmocom/gsm/sysinfo.h>`
`#include <osmocom/gprs/protocol/gsm_04_60.h>`

Go to the source code of this file.

## Data Structures

struct | osmo_gsm48_si_pch_nch_info
struct | osmo_gsm48_si_vbs_vgcs_options
struct | osmo_gsm48_si_dtm_support
struct | osmo_gsm48_si_gprs_ms_txpwr_max_ccch
struct | osmo_gsm48_si6_ro_info
struct | osmo_gsm48_si_selection_params
struct | osmo_gsm48_si_power_offset
struct | osmo_gsm48_si3_gprs_ind
struct | osmo_gsm48_lsa_params
struct | osmo_gsm48_si_ro_info
struct | osmo_gsm48_si13_info

## Macros

#define | SI2Q_MAX_NUM 16
#define | SI2Q_MAX_LEN 160
#define | SI2Q_MIN_LEN 18

## Functions

int | osmo_gsm48_rest_octets_si1_encode (uint8_t *data, uint8_t *nch_pos, int is1800_net)
int | osmo_gsm48_rest_octets_si2quater_encode (uint8_t *data, uint8_t si2q_index, uint8_t si2q_count, const uint16_t *uarfcn_list, size_t *u_offset, size_t uarfcn_length, uint16_t *scramble_list, struct osmo_earfcn_si2q *si2quater_neigh_list, size_t *e_offset)
int | osmo_gsm48_rest_octets_si6_encode (uint8_t *data, const struct osmo_gsm48_si6_ro_info *in)
int | osmo_gsm48_rest_octets_si3_encode (uint8_t *data, const struct osmo_gsm48_si_ro_info *si3)
int | osmo_gsm48_rest_octets_si4_encode (uint8_t *data, const struct osmo_gsm48_si_ro_info *si4, int len)
int | osmo_gsm48_rest_octets_si13_decode (struct osmo_gsm48_si13_info *si13, const uint8_t *data)
| Decode SI13 Rest Octests (04.08 Chapter 10.5.2.37b).
int | osmo_gsm48_rest_octets_si13_encode (uint8_t *data, const struct osmo_gsm48_si13_info *si13)
void | osmo_gsm48_rest_octets_si3_decode (struct osmo_gsm48_si_ro_info *si3, const uint8_t *data)
| Decode SI3 Rest Octests (Chapter 10.5.2.34 / Table 10.4.72).
void | osmo_gsm48_rest_octets_si4_decode (struct osmo_gsm48_si_ro_info *si4, const uint8_t *data, int len)

## Macro Definition Documentation

## SI2Q_MAX_LEN

#define SI2Q_MAX_LEN 160

## SI2Q_MAX_NUM

#define SI2Q_MAX_NUM 16

## SI2Q_MIN_LEN

#define SI2Q_MIN_LEN 18

## Function Documentation

## osmo_gsm48_rest_octets_si13_decode()

int osmo_gsm48_rest_octets_si13_decode | ( | struct osmo_gsm48_si13_info * | si13,
|  | const uint8_t * | data
| ) |  |

Decode SI13 Rest Octests (04.08 Chapter 10.5.2.37b).

Parameters

  [out] | si13 | decoded SI13 rest octets
  [in] | encoded | SI13 rest octets

Returns
  parsed bits on success, negative on error

References bitvec_get_bit_high(), bitvec_get_uint(), bitvec::data, decode_gprs_cell_opt(), decode_gprs_pwr_ctrl_pars(), ENOTSUP, H, and len.

## osmo_gsm48_rest_octets_si13_encode()

int osmo_gsm48_rest_octets_si13_encode | ( | uint8_t * | data,
|  | const struct osmo_gsm48_si13_info * | si13
| ) |  |

References append_gprs_cell_opt(), append_gprs_mobile_alloc(), append_gprs_pwr_ctrl_pars(), bitvec_set_bit(), bitvec_set_uint(), bitvec_spare_padding(), bitvec::data, H, L, and len.

## osmo_gsm48_rest_octets_si1_encode()

int osmo_gsm48_rest_octets_si1_encode | ( | uint8_t * | data,
|  | uint8_t * | nch_pos,
|  | int | is1800_net
| ) |  |

References bitvec_set_bit(), bitvec_set_uint(), bitvec_spare_padding(), bitvec::data, H, L, and len.

## osmo_gsm48_rest_octets_si2quater_encode()

int osmo_gsm48_rest_octets_si2quater_encode | ( | uint8_t * | data,
|  | uint8_t | si2q_index,
|  | uint8_t | si2q_count,
|  | const uint16_t * | uarfcn_list,
|  | size_t * | u_offset,
|  | size_t | uarfcn_length,
|  | uint16_t * | scramble_list,
|  | struct osmo_earfcn_si2q * | si2quater_neigh_list,
|  | size_t * | e_offset
| ) |  |

References append_earfcn(), append_uarfcns(), bitvec_set_bit(), bitvec_set_uint(), bitvec_spare_padding(), bitvec_zero(), bitvec::data, L, len, si2q_earfcn_count(), and SI2Q_MAX_LEN.

## osmo_gsm48_rest_octets_si3_decode()

void osmo_gsm48_rest_octets_si3_decode | ( | struct osmo_gsm48_si_ro_info * | si3,
|  | const uint8_t * | data
| ) |  |

Decode SI3 Rest Octests (Chapter 10.5.2.34 / Table 10.4.72).

Parameters

  [out] | si3 | decoded SI3 rest octets
  [in] | encoded | SI3 rest octets, 4 octets long

References bitvec_get_bit_high(), bitvec_get_uint(), osmo_gsm48_si_selection_params::cbq, osmo_gsm48_si_selection_params::cell_resel_off, bitvec::data, H, len, osmo_gsm48_si_selection_params::penalty_time, osmo_gsm48_si_power_offset::power_offset, osmo_gsm48_si_selection_params::present, and osmo_gsm48_si_selection_params::temp_offs.

## osmo_gsm48_rest_octets_si3_encode()

int osmo_gsm48_rest_octets_si3_encode | ( | uint8_t * | data,
|  | const struct osmo_gsm48_si_ro_info * | si3
| ) |  |

References append_gprs_ind(), append_power_offset(), append_selection_params(), bitvec_set_bit(), bitvec_set_uint(), bitvec_spare_padding(), bitvec::data, H, L, and len.

## osmo_gsm48_rest_octets_si4_decode()

void osmo_gsm48_rest_octets_si4_decode | ( | struct osmo_gsm48_si_ro_info * | si4,
|  | const uint8_t * | data,
|  | int | len
| ) |  |

References bitvec_get_bit_high(), bitvec_get_uint(), osmo_gsm48_si_selection_params::cbq, osmo_gsm48_si_selection_params::cell_resel_off, bitvec::data, H, len, osmo_gsm48_si_selection_params::penalty_time, osmo_gsm48_si_power_offset::power_offset, osmo_gsm48_si_selection_params::present, and osmo_gsm48_si_selection_params::temp_offs.

## osmo_gsm48_rest_octets_si4_encode()

int osmo_gsm48_rest_octets_si4_encode | ( | uint8_t * | data,
|  | const struct osmo_gsm48_si_ro_info * | si4,
|  | int | len
| ) |  |

References append_gprs_ind(), append_lsa_params(), append_power_offset(), append_selection_params(), bitvec_set_bit(), bitvec_set_uint(), bitvec::data, H, L, and len.

## osmo_gsm48_rest_octets_si6_encode()

int osmo_gsm48_rest_octets_si6_encode | ( | uint8_t * | data,
|  | const struct osmo_gsm48_si6_ro_info * | in
| ) |  |

References bitvec_set_bit(), bitvec_set_uint(), bitvec_spare_padding(), bitvec::data, H, L, and len.